// FARRSubScript-specific variables
displayname="FARRSubScript";
versionstring="1.03";
releasedatestring="5.1.2009";
author="Authors";
updateurl="";
homepageurl="";
shortdescription="FSubScript";
longdescription="FSubScript";
advconfigstring="FSubScript";
readmestring="FSubScript";
iconfilename="FSubScript.ico";
aliasstr="fssc";
regexstr="";
regexfilterstr="";
keywordstr="";
scorestr="300";
// FARR constants
// type
UNKNOWN=0; FILE=1; FOLDER=2; ALIAS=3; URL=4; PLUGIN=5; CLIP=6; ALIASFILE=7;
IMMEDIATE_DISPLAY=0; ADD_SCORE=1; MATCH_AGAINST_SEARCH=2; ADD_SCORE_W_PATS=3;
MATCH_AGAINST_SEARCH_W_PATS=4;
// search state
STOPPED=0; SEARCHING=1;
//
HANDLED=1; CLOSE=2;

//global variable defining which script is in charge
activeScript = "";

// FARR.setStrValue() wrappers
// XXX: global 'namespace' feels like it's getting crowded...
//      how about wrapping these up in an object?  also, automating
//      their creation a bit?

function receiveKeys(){ FARR.setStrValue("receivekeys", "1"); }
function setStatusBarMenu(txt){FARR.setStrValue("addmenu.statusbar",txt);}
function setContextMenu(txt){FARR.setStrValue("addmenu.contextmenu",txt);}
function setStatusBar(txt) { FARR.setStrValue("statusbar", txt); }
function setSearch(txt) { FARR.setStrValue("setsearch", txt); }
function setSearchNoGo(txt) { FARR.setStrValue("setsearchnogo", txt); }
function stopSearch() { FARR.setStrValue("stopsearch"); }
function hideWindow() { FARR.setStrValue("window.hide"); }
function showWindow() { FARR.setStrValue("window.show"); }
function toggleWindow() { FARR.setStrValue("window.toggle"); }
function setRichEditMode(txt) {
   receiveKeys();
   FARR.setStrValue("window.richeditmode", txt);
}
function setRichEditHeight(height) {
  FARR.setStrValue("window.richeditheight", height);
}
function setRichEditWidth(width) {
  FARR.setStrValue("window.richeditwidth", width);
}
function setShowAllMode() { FARR.setStrValue("setshowallmode"); }
function exit() { FARR.setStrValue("exit"); }
function reportError(txt) { FARR.setStrValue("reporterror", txt); }

function setCliboard(txt) { FARR.setStrValue("clipboard",txt); }
function pasteClipboardToLastActiveWindow(txt) {
  FARR.setStrValue("PasteClipboardToLastActiveWindow", txt)
    }
function displayAlertMessage(txt) {
  FARR.setStrValue("DisplayAlertMessage", txt);
}
function displayAlertMessageNoTimeout(txt) {
  FARR.setStrValue("DisplayAlertMessageNoTimeout", txt); }
function displayBalloonMessage(txt) {
  FARR.setStrValue("DisplayBalloonMessage", txt);
}
function execWebbrowserEmbededJavascript(txt) {
  FARR.setStrValue("EmbeddedWb.ExecJavascript", txt);
}
function forceResultFilter(txt) { FARR.setStrValue("ForceResultFilter", txt); }
function setUserVar(path, value) {
  if(typeof(value) === "string"){
    FARR.setStrValue("uservar." +path, value);
  }else if(typeof(value) === "object"){
    var str = objToStr(path, value);
    var s = str.split("\n");
    for(var i in s){
      var a = s[i].match(/^\s*([^= ]+?)\s*=\s*(.+?)\s*$/);
      if(a && a[1] && a[2] && a[1] != "" && a[2] != ""){
        var j = "uservar." +a[1];
        var k = a[2];
        FARR.setStrValue("uservar." +a[1], a[2]);
      }
    }
  }
}

// FARR.getStrValue() wrappers
function getUserVar(path) {
  return FARR.getStrValue("uservar." + path);
}
function HTMLLength() {
  return FARR.getStrValue("EmbeddedWb.ContentsLength");
}
function resolve(cmd){
  return FARR.getStrValue("resolve:"+cmd);
}

// launch-specific wrappers
function launch(txt) { FARR.setStrValue("launch", txt); }
function preload(txt,postCommands) {
  if(typeof(postCommands) === "undefined") postCommands = "";
  FARR.setStrValue("postpluginlaunch","preload "+txt+";;;"+postCommands);
}

function paste(txt) { FARR.setStrValue("launch", "paste " + txt); }
function copyClip(txt) { FARR.setStrValue("launch", "copyclip " + txt); }
function restartSearch(txt) {
  FARR.setStrValue("launch", "restartsearch " + txt);
}
function doSearch(txt) { FARR.setStrValue("launch", "dosearch " + txt); }
function doSearchOnTrigger(txt) {
  FARR.setStrValue("launch", "dosearchontrigger " + txt);
}
// txt: text with \n as newlines
function showMemo(txt) {
  receiveKeys();
  FARR.setStrValue("launch", "showmemo " + txt);
}
function showFile(filename) {
  receiveKeys();
  FARR.setStrValue("launch", "showfile " + filename);
}
function showFileRTF(filename) {
  receiveKeys();
  FARR.setStrValue("launch", "showfilertf " + filename);
}
function showFileHTML(filename) {
  receiveKeys();
  FARR.setStrValue("launch", "showfilehtml " + filename);
}
function showHTML(txt) {
  receiveKeys();
  FARR.setStrValue("launch", "showhtml " + txt);
}
// txt: url
function htmlViewURL(txt) {
  receiveKeys();
  FARR.setStrValue("launch", "htmlviewurl " + txt);
}
// txt: searchedit, mainpanel
function setFocus(txt) { FARR.setStrValue("launch", "setfocus " + txt); }
// txt: list, memo, html, user, spreadsheet
function setViewMode(txt) {
  FARR.setStrValue("launch", "setviewmode " + txt);
}
function pcommand(txt) { FARR.setStrValue("launch", "pcommand " + txt); }
function setSize(minwidth, minheight, maxwidth, maxheight) {
  FARR.setStrValue("launch", "setsize " +
                   minwidth + ", " + minheight + ", " +
                   maxwidth + ", " + maxheight);
}
// XXX: bool: 0 or 1?
function setHTMLSafe(bool) {
  FARR.setStrValue("launch", "sethtmlsafe " + bool);
}
function showPleaseWait(txt) {
  FARR.setStrValue("launch", "showpleasewait " + txt);
}
function hidePleaseWait() { FARR.setStrValue("launch", "hidepleasewait"); }
// Why not to use it?
function alert(txt) { FARR.debug(txt); }
// Not useful for plugins
// function sleep(ms) { FARR.setStrValue("launch", "sleep " + ms); }
//
function error(txt) {
  displayAlertMessage(txt);
}
var plugins = {}
  var fso = new ActiveXObject("Scripting.FileSystemObject");

function getTextFile(path) {
  var objFile = fso.GetFile(path);
  var objTS = objFile.OpenAsTextStream(1, 0);
  var txt = objTS.Read(objFile.Size);
  objTS.Close();
  return txt;
}

var g_currentDirectory;

var maxdepth = 2;
function onInit(directory) {
  g_currentDirectory = directory;

  // loading of hard Coded essential Extensions
  try{
    eval(getTextFile(directory+"\\hardCodedExtensions.js"));
  }catch(er){
    error("error occured while loading hardCodedExtensions.js");
  }

  function processFolder(foldername, depth, scriptname) {
    var fld = fso.GetFolder(foldername);
    var fldc = new Enumerator(fld.SubFolders);
    var fln;
    for (; !fldc.atEnd(); fldc.moveNext()) {
      try {
        var currentDirectory = fldc.item(); // used for eval(), full path
        fln = currentDirectory + "\\"+scriptname;
        if (fso.FileExists(fln)) {
          var folder_name = currentDirectory.Name;
          var str = getTextFile(fln);
          if(folder_name.search(/^.*_deactivated$/) == -1){
            eval(str);
          }
        }
      } catch (e) {
        error("error occured while loading " +
              currentDirectory + "\\"+scriptname+"\n" +
              "message: " + e.message + " " + "name: " + e.name);
      }
      if (depth < maxdepth) {
        processFolder(currentDirectory, depth + 1, scriptname);
      }
    }
  }

  processFolder(directory + "\\..", 0, "fsubscript_ext.js");
  processFolder(directory + "\\..", 0, "fsubscript.js");
  var pi;
  for (var i in plugins) {
    try {
      pi = plugins[i];
      if (!pi.init) { continue; }
      pi.init();
    } catch (e) {
      error("plugin " + i + " has failed on init: " +
            "message: " + e.message + " " + "name: " + e.name);
    }
  }
}

function onSearchBegin(querykey, explicit, queryraw, querynokeyword,
                       modifier, triggermethod) {
  function cleanup(errortxt) {
    if (errortxt) {
      reportError("FSubScript Warning: " + errortxt);
    }
    FARR.setState(querykey, STOPPED);
  }

  FARR.setState(querykey, SEARCHING);
  // qma: (q)uery (m)atch (a)rray
  qma = queryraw.match("^([^ ]+) ?(.*)"); // XXX: simplify?
  var first, rest;
  if (qma) {
    first = qma[1];
    rest = qma[2];
    if (first === "aplugins") {
      for (var i in plugins) {
        var pi = plugins[i];
        var title = (pi.displayName || i) + " via FSubScript " +
                    "(" + pi.version + " - " + pi.lastChange + ")";
        FARR.emitResult(querykey, title, pi.aliasstr, pi.icon || iconfilename,
                        ALIAS, MATCH_AGAINST_SEARCH, 99, pi.aliasstr);
      }
      cleanup(); return;
    }
  }
  /*
    2008-11-23, 2008-12-02 mouser (paraphrased + updated):
    1) if  plugin has regex
          if regex matches
            set exact flag to true and set filterstr to regexfilter
//          else if string typed is: ^KEYWORD$ or ^KEYWORD $
//            trigger the non-regex search
    2) if "plugin does not have regex or plugin's regex didn't match" and
          first word matches
            set exact flag to true and set filterstr to rest of string
    3) call setfilter
          if filterstr is true -or-
          if plugin alias matched, call w/ filterstr set to ""
    4) call search if a plugin handles searching, else skip to next plugin
    5) call stopsearch if exact is true
  */
  // pi: (p)lugin (i)
  // pa: (p)lugin (a)lias
  // prs: (p)lugin (r)egex (s)tring
  // prsf: (p)lugin (r)egex (s)earch (f)liter // XXX
  // prfg: (p)lugin (r)egex (f)ilter (g)roup
  // mpa: (m)atched (p)lugin (a)lias
  // pqma: (p)lugin (q)uery (m)atch (a)rray
  var pi, pa, prs, prfg;
  var mpa, pqma, filterstr, exact;
  for (var i in plugins) {
    pi = plugins[i];
    pa = pi.aliasstr; // can be null or undefined
    prs = pi.regexstr; // can be null or undefined
    //prsf = pi.regexsearchfilter;
    // approximate initially by using regexfiltergroup
    prfg = pi.regexfiltergroup; // can be null or undefined
    mpa = false;
    pqma = null;
    exact = false;
    filterstr = null;
 //   try {
      mpa = Boolean(first && pa && (first === pa));
      // 1) plugin has regex
      if (prs) {
        pqma = queryraw.match(prs);
        if (pqma) {
          exact = true;
          if (prfg && pqma[prfg]) {
            filterstr = pqma[prfg];
          }
        }
      }
      // 2) "no regex or regex didn't match" and first word matches plugin aliasstr
      if ((!prs || !pqma) && mpa) {
        exact = true;
        filterstr = rest;
      }
      // 3) filter if necessary
      if (filterstr) {
        forceResultFilter(filterstr);
      } else {
        if (mpa) {
          forceResultFilter("");
        }
      }
      // 4) search if necessary
      if (!pi.search) { continue; }
      pi.search(querykey, exact, queryraw, querynokeyword, modifier,
                triggermethod);
       // settings/help to be displayed in menu
       if(exact && pi.help){
         setStatusBarMenu("type=item|caption=Help|hint=Help for the plugin|icon=help2.ico|launch=htmlviewurl "+pi.help);
       }
       if(exact && pi.settings){
         setStatusBarMenu("type=item|caption=Settings|hint=Settings for the plugin|icon=options.ico|launch=restartsearch "+aliasstr+" "+pi.aliasstr);
       }
      // 5) stop if necessary
      if (exact) {
        stopSearch();
        break;
      }
  //  } catch (e) {
  //    error("plugin " + i + " has failed on search: " +
  //          "message: " + e.message + " " + "name: " + e.name);
  //   }
  }
  cleanup();
  if(!explicit) return;
  if(qma[2]){
    for(var i in plugins){
      if(plugins[i].aliasstr == qma[2] &&
         plugins[i].settings && plugins[i].settings.show){
        plugins[i].settings.onFinish = "restartsearch "+aliasstr;
        plugins[i].settings.show();
        return;
      }
    }
  }
  //try{
    show_fssc();
  //}catch(e){
  //  error("Plugin has failed on show_fssc: " +
  //    "message: " + e.message + " " + "name: " + e.name);
  //}

}

function onProcessTrigger(path, title, groupname, pluginid, thispluginid, score, entrytype, args) {
  var pi, r;
  for (var i in plugins) {
    try {
      pi = plugins[i];
      if (!pi.trigger) { continue; }
      r = pi.trigger(path, title, groupname, pluginid, thispluginid, score,
                     entrytype, args);
      if ((r & 3) != 0) // XXX: may be we can use 'constants' for readability?
        return r; // stop if stop or closed is required
    } catch (e) {
      error("plugin " + i + " has failed on trigger: " +
            "message: " + e.message + " " + "name: " + e.name);
    }
  }
}
function onReceiveKey(key, altpressed, controlpressed, shiftpressed) {
  var pi, r, al = false;
  var pl = pluginInCharge();
  if(pl) {
    try {
      pi = plugins[pl];
      if (pi.receive) {
        r = pi.receive(key, altpressed, controlpressed, shiftpressed);
        if (r) { return true; }
      }
    } catch (e) {
      error("plugin " + i + " has failed on receive: " +
            "message: " + e.message + " " + "name: " + e.name);
    }
  }
  return false;
}
function onWin32Message(wparam, lparam) {
}

function onDoAdvConfig() {
  return true;
}

function onDoShowReadMe() {
}

function onSetStrValue(name, value) {
  var r = false;

  // settings implementation
  try {
    if(checkSettings(name,value)) r = true;
  } catch (e) {
    error("pcommand has failed on checkSettings: " + "message: " + e.message + " " + "name: " + e.name);
  }

  // activating of scripts implementation
  try {
    if(checkActive(name,value)) r = true;
  } catch (e) {
    error("pcommand has failed on checkActive: " + "message: " + e.message + " " + "name: " + e.name);
  }

  // execute command implementation
  try {
    if(executeCall(name,value)) r = true;
  } catch (e) {
    error("pcommand has failed on executeCall: " + "message: " + e.message + " " + "name: " + e.name);
  }

  for (var i in plugins) {
    try {
      pi = plugins[i];
      if (pi && pi.setStrValue && pi.setStrValue(name, value)) {
        r = true;
      }
    } catch (e) {
      error("plugin " + i + " has failed on setStrValue : " +
            "message: " + e.message + " " + "name: " + e.name);
    }
  }
  return r;
}

function onIdleTime(idle){
  var pl = pluginInCharge();
  if(pl){
    try {
      if (plugins[pl] && plugins[pl].idleTime) plugins[pl].idleTime(idle);
    } catch (e) {
      error("plugin " + i + " has failed on idleTime: " +
            "message: " + e.message + " " + "name: " + e.name);
    }
  }
}

//******************************************************
// Helping functions and variables

//returns an array of paths to files specified in parameters
function getScriptList(folder, script, depth){
  if(typeof(depth) === "undefined") depth = 0;
  var path = [];
  var fld = fso.GetFolder(folder);
  var fldc = new Enumerator(fld.SubFolders);
  for (; !fldc.atEnd(); fldc.moveNext()) {
    var curDir = fldc.item();
    if(fso.FileExists(curDir + "\\" + script)) {
      path.push(curDir);
    }
    if (depth < maxdepth) {
      path = path.concat(getScriptList(curDir, script, depth + 1));
    }
  }
  
  return path;
}

//recognizes which plugin is in charge by comparing aliasstr to qma
//therefore qma must be global
var qma;
function pluginInCharge(){
  if(activeScript != ""){
    return activeScript;
  }else{
    for(var i in plugins){
      if(plugins[i].aliasstr && qma && qma[1] && qma[1] != "" &&
         plugins[i].aliasstr == qma[1]) {
        return i;
      }
    }
    return false;
  }
}

//pcommand which executes its content
function executeCall(name, value){
  if(name == "pcommand"){
    var rg = new RegExp('^execute\\s+(.+)\\s*$');
    var u = value.match(rg);
    if(u && u[1] && u[1] != ""){
      try{
        eval(u[1]);
      }catch(e){
        error("pcommand has failed on execute: " +
            "message: " + e.message + " " + "name: " + e.name);
      }
      return true;
    }
  }
}

//monitors activate/deactivate pcommands
function checkActive(name,value){
  if(name == "pcommand"){
    var rg1 = new RegExp('^activate_script\\s+(.+)\\s*$');
    var u1 = value.match(rg1);
    if(u1 && u1[1]){
      u1[1] = escape(unescape(u1[1]));
      var list = getScriptList(g_currentDirectory+"\\..","fsubscript.js");
      if(u1[1] == "all"){
        for(var i in list){
          var folder = fso.GetFolder(list[i]);
          if(folder.Name.search(/^.*_deactivated$/) != -1){
            folder.Name = folder.Name.replace(/^(.*)_deactivated$/,"$1");
          }
        }
        restartSearch(aliasstr);
        return true;
      }else{
        var id = unescape(u1[1]);
        if(fso.FolderExists(id)){
          var f1 = fso.GetFolder(id);
          if(f1.Name.search(/^.*_deactivated$/) != -1){
            f1.Name = f1.Name.replace(/^(.*)_deactivated$/,"$1");
          }
          restartSearch(aliasstr);
        }
        return true;
      }
    }

    var rg2 = new RegExp('^deactivate_script\\s+(.+)\\s*$');
    var u2 = value.match(rg2);
    if(u2 && u2[1]){
      u2[1] = escape(unescape(u2[1]));
      var list2 = getScriptList(g_currentDirectory+"\\..","fsubscript.js");
      if(u2[1] == "all"){
        for(var i2 in list2){
          var f2 = fso.GetFolder(list2[i2]);
          if(f2.Name.search(/^.*_deactivated$/) == -1){
            f2.Name = f2.Name + "_deactivated";
          }
        }
        restartSearch(aliasstr);
        return true;
      }else{
        var id2 = unescape(u2[1]);
        if(fso.FolderExists(id2)){
          var f3 = fso.GetFolder(id2);
          if(f3.Name.search(/^.*_deactivated$/) == -1){
            f3.Name = f3.Name + "_deactivated";
          }
          restartSearch(aliasstr);
        }
        return true;
      }
    }
    if(value.search(/^reload$/) != -1){
      showHTML("Reloading, please wait...");
      preload(displayname,"restartsearch "+aliasstr);
      return true;
    }
  }
  return false;
}

// monitors settings pcommands
var temp_set = {}; // object for alias settings objects
function checkSettings(name, value){
  if(name == "pcommand"){
    // receive command to show settings window
    // (.+?) is settings file path
    // (.+) is set of commands to be called on form submit
    // division of commands is done by &&&
    var rg1 = new RegExp('^settings\\s+(.+?)(?:\\s+&&(.+)){0,1}\\s*$');
    var u1 = value.match(rg1);
    if(u1 && u1[1]){
      var aliasID = "alias_"+Math.ceil(Math.random()*10000);
      temp_set[aliasID] = new Settings(u1[1],aliasID,"alias");
      if(u1[2]){
        var cmd = u1[2].replace(/&&/g,";;;");
        temp_set[aliasID].onFinish = cmd;

      }
      temp_set[aliasID].show();
      return true;
    }
    // internal pcommand call to collect form data
    // first (.+?) is pluginID.variable correct javascript path (example: colors.settings.one)
    // second (.+?) is variable (instance) name
    var rg2 = new RegExp('^collect_settings\\s+(.+?)/\\?(.+?)\\s*$');
    var u2 = value.match(rg2);
    if(u2){
      var fj = strToObj(decodeURIComponent(u2[2].replace(/\+/g,"%20").replace(/&/g,"\n")));
      // call onSubmit function in plugin if exists
      var pi;
      var isAlias = u2[1].search(/^alias_\d+\.alias$/);
      if(isAlias != -1){
        pi = temp_set[u2[1].replace(/\.alias$/,"")];
      }else{
        try{
          pi = eval("plugins."+u2[1]);
        }catch(e){
          error("pcommand has failed on collect_settings: " +
            "message: " + e.message + " " + "name: " + e.name);
        }
      }
      if(pi && pi.onSubmit){
        var fj_temp = pi.onSubmit(fj);
        if(fj_temp && typeof(fj_temp) === 'object') fj = fj_temp;
      }

      setUserVar("",fj);

      if(isAlias != -1 && pi.onFinish){
        launch(pi.onFinish);
      }else{
        showHTML("Reloading, please wait...");
        preload(displayname, pi.onFinish?pi.onFinish:"restartsearch "+aliasstr);
      }
      return true;
    }
  }
  return false;
}

//Settings object
// path: url path of html file
// pluginID: ID of the plugin
// varname: name of a created variable (instance)
function Settings(path, pluginID, varName){
  if(!path){
    throw("path for settings object ("+pluginID+", "+varName+") is missing");
    return;
  }
  if(!pluginID){
    throw("pluginID for settings object ("+path+", "+varName+") is missing");
    return;
  }
  if(!varName){
    throw("varName for settings object ("+pluginID+", "+path+") is missing");
    return;
  }
  this.path = path;
  this.pluginID = pluginID;
  this.varName = varName;
  this.onLoad = false;
  this.onSubmit = false;
  this.onFinish = false;

  this.show = function(){
    if (fso.FileExists(path)) {
      var str = getTextFile(path);
      if(this.onLoad){
        var str_temp = this.onLoad(str);
        if(str_temp && typeof(str_temp) == 'string' && str_temp != ""){
          str = str_temp;
        }else{
          throw("onLoad function of "+this.pluginID+"("+this.varName+") script must return a modified string");
          return;
        }
      }
      var sv = "";
      var names = str.match(/(?:name|Name|NAME)\s*=\s*(?:".*?"|'.*?'|[^'">\s]+)/g);
      for(var i = 0; i < names.length; i++){
        var ns = names[i].replace(/^(?:name|Name|NAME)\s*=\s*["']{0,1}(.*?)["']{0,1}$/,"$1").trim();
        var nv = FARR.getStrValue("uservar."+ns);
        if(nv && typeof(nv) === "string" && nv != ""){
          sv += escape(ns)+"="+escape(nv)+"&";
        }
      }
      str += '<script type="text/javascript"><!--\n';
      if(sv != ""){
        str += 'var q = "'+sv+'";\n\
            var list = q.split("&");\n\
            for(var i in list) {\n\
              var s = list[i].replace(/^\\s+|\\s+$/g,"");\n\
              if(s && s != ""){\n\
                var v = s.split("=");\n\
                if(v && v[0] && v[1]){\n\
                  if( !eval("document.forms[0][\'"+unescape(v[0])+"\']") ) { continue; }\n\
                  document["forms"][0][unescape(v[0])]["value"]=unescape(v[1]);\n\
                }\n\
                \n\
              }\n\
            }';
      }
      str += 'document.forms[0].method="get";\n\
        document.forms[0].action="farr://pcommand collect_settings '+this.pluginID+'.'+this.varName+'";\n\
        //--></script>';
      showHTML(str);
    }else{
      throw("The path ("+path+") of the plugin ("+pluginID+", "+varName+") does not exist");
      return;
    }
  }
}

// object containing plugins which exist but are not activated
var deactivated = {};

//Show fssc onsearchbegin
function show_fssc(){
  function setInfo(currentDirectory){
    var fln1 = currentDirectory + "\\fsubscript.js";
    var fln2 = currentDirectory.replace(/_deactivated$/,"") + "\\fsubscript.js";
    var fln;

    if(fso.FileExists(fln1)) fln = fln1;
    else if(fso.FileExists(fln2)) fln = fln2;

    if (fso.FileExists(fln)) {
      var str = getTextFile(fln);
      var id = escape(currentDirectory);
      deactivated[id] = {};
      deactivated[id].description = "";
      deactivated[id].displayName = "";

      var desc = str.match(/description\s*(?:\:|=)\s*(?:"((?:[^\\"]|\\.)*)"|'((?:[^\\']|\\.)*)')/);
      if(desc){
        if(desc[1]) deactivated[id].description = desc[1];
        else if(desc[2]) deactivated[id].description = desc[2];
      }
      var disp = str.match(/displayName\s*(?:\:|=)\s*(?:"((?:[^\\"]|\\.)*)"|'((?:[^\\']|\\.)*)')/);
      if(disp){
        if(disp[1]) deactivated[id].displayName = disp[1];
        else if(disp[2]) deactivated[id].displayName = disp[2];
      }
      return deactivated[id];
    }
    return {};
  }

  setStatusBarMenu("type=item|caption=Help|hint=FSubScript Help|icon=help2.ico|launch=htmlviewurl "+g_currentDirectory+"\\help.html");
  var rm = false;
    var string =
"<div><a href='javascript: ;' onclick='javascript:window.location=\"farr://pcommand reload /STAYOPEN\"'>Reload the main plugin</a></div>\
<div><a href='javascript: ;' onclick='javascript:window.location=\"farr://pcommand deactivate_script all /STAYOPEN\"'>Deactivate all plugins</a></div>\
<div><a href='javascript: ;' onclick='javascript:window.location=\"farr://pcommand activate_script all /STAYOPEN\"'>Activate all plugins</a></div>\
<br/>Activated plug-ins:<br/>";
    var template = getTextFile(g_currentDirectory+"\\manager.html");
    if(template && typeof(template) === "string" && template != ""){
      var list = getScriptList(g_currentDirectory+"\\..", "fsubscript.js");
      var a_obj = [];
      var d_obj = [];
      for(var l in list){
        var found = false;
        var li = list[l].Path;
        for(var i in plugins){
          var pi = plugins[i];
          if(pi && pi.directory && pi.directory + "" === li){
            found = true;
            if(li.search(/_deactivated$/) == -1){
              a_obj.push({
                  "tb_bg_color":"#FAFAD2",
                  "icon":pi.icon,
                  "name":"<a href='farr://restartsearch "+pi.aliasstr+"\\s /STAYOPEN' >"+pi.displayName+"</a>",
                  "version":(pi.version?pi.version:""),
                  "last_change":(pi.lastChange?pi.lastChange:""),
                  "description":(pi.description?pi.description:""),
                  "settings":pi.settings?'<a href="javascript: ;" onclick="javascript:window.location=\'farr://restartsearch '+aliasstr+' '+pi.aliasstr+'\'">settings</a>':"",
                  "deactivate":'<a href="javascript: ;" onclick="javascript:window.location=\'farr://pcommand deactivate_script '+escape(li)+'\'">deactivate</a>',
                  "help":(pi.help?"<a href='farr://htmlviewurl "+pi.help+"' >Help</a>":"")
                });
            }else{
              rm = true;
              a_obj.push({
                  "tb_bg_color":"Aquamarine",
                  "icon":g_currentDirectory+"\\deactivated.png",
                  "name":pi.displayName,
                  "version":(pi.version?pi.version:""),
                  "last_change":(pi.lastChange?pi.lastChange:""),
                  "description":(pi.description?pi.description:""),
                  "settings":"",
                  "deactivate":'<a href="javascript: ;" onclick="javascript:window.location=\'farr://pcommand activate_script '+escape(li)+'\'">To be deactivated</a>',
                  "help":(pi.help?"<a href='farr://htmlviewurl "+pi.help+"' >Help</a>":"")
                });
            }
            break;
          }
        }
        if(!found){
          var x = li.search(/^.*_deactivated$/) == -1 ? li + "_deactivated" : li;
          var de = deactivated[escape(x)];
          if(!de){
            de = setInfo(x);
          }
          if(li.search(/_deactivated$/) != -1){
            d_obj.push({
                "tb_bg_color":"#D3D3D3",
                "icon":g_currentDirectory+"\\deactivated.png",
                "name":de.displayName,
                "version":"",
                "last_change":"Folder: "+li.replace(/^.*\\/,""),
                "description":(de.description?de.description:""),
                "deactivate":'<a href="javascript: ;" onclick="javascript:window.location=\'farr://pcommand activate_script '+escape(li)+'\'">activate</a>',
                "settings":"",
                "help":""
              });
          }else{
            rm = true;
            d_obj.push({
                "tb_bg_color":"Aquamarine",
                "icon":g_currentDirectory+"\\deactivated.png",
                "name":de.displayName,
                "version":"",
                "last_change":"Folder: "+li.replace(/^.*\\/,""),
                "description":(de.description?de.description:""),
                "deactivate":'<a href="javascript: ;" onclick="javascript:window.location=\'farr://pcommand deactivate_script '+escape(li)+'\'">To be activated</a>',
                "settings":"",
                "help":""
              });
          }
        }
      }
      string = (rm ? "<div style='background-color:Aquamarine;text-align:center;'>Reload the plugin to take actions into effect!</div>" : "") + string;
      for(var o1 in a_obj){
        string += template.supplant(a_obj[o1]);
      }
      string += "<br/>Deactivated plug-ins:<br/>"
      for(var o2 in d_obj){
        string += template.supplant(d_obj[o2]);
      }
      showHTML(string);
    }else{
      throw("Error when reading: "+g_currentDirectory+"\\manager.html. It does not exist or it is empty.");
    }
  }

// converts "a.b.c.d = value\nc.d = value" into an object
// str: string containing a list
// returns and object
function strToObj(str){

  function extend(destination, source) {
    for (var i in source) {
      if(typeof(source[i]) === "object" && destination[i] &&
         typeof(destination[i]) === "object"){
        destination[i] = extend(destination[i],source[i]);
      }else{
        destination[i] = source[i];
      }
    }
    return destination;
  }

  function quote(string) {
    var escapable = /[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g;
    var  meta = {
            '\b': '\\b',
            '\t': '\\t',
            '\n': '\\n',
            '\f': '\\f',
            '\r': '\\r',
            '"' : '\\"',
            '\\': '\\\\'
        };
    escapable.lastIndex = 0;
    return escapable.test(string) ?
      '"' + string.replace(escapable, function (a) {
        var c = meta[a];
        return typeof c === 'string' ? c :
          '\\u' + ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
    }) + '"' :
    '"' + string + '"';
  }
  var array = {};
  var uvs = str.split("\n");
  for(var i in uvs){
    var a = uvs[i].match(/^\s*([^=]*)\s*=\s*(.*)\s*$/);
    if(a && a[1] && a[2] && a[1] != "" && a[2] != ""){
      var oc = a[1].match(/\./g);
      if(!oc){
        oc = 0;
      } else {
        oc = oc.length;
      }
      var str = '{"'+a[1].replace(/\./g,'":{"')+'":'+quote(a[2])+'}'.repeat(oc+1);
      var source = JSON.parse(str);
      if(source){
        array = extend(array, source);
      }
    }
  }
  return array;
}

// converts an object into "a.b.c.d = value\nc.d = value"
// path: path to be added in front of the object
// obj: object
// returns a string
function objToStr(path,obj){
  if(typeof(path) !== "string") throw("Error in objToStr function. Path is missing or not a string.")
  if(typeof(obj) !== "object") throw("Error in objToStr function. Object is missing or not an object.")
  var str = "";
  for(var i in obj){
    if(typeof(obj[i]) === "object"){
      str += objToStr((path != "" ? (path + ".") : "") + i, obj[i]);
    }else if(typeof(obj[i]) === "string" || typeof(obj[i]) === "boolean" ||
             typeof(obj[i]) === "number") {
      str += (path != "" ? (path + ".") : "") + i + " = " + obj[i]+"\n";
    }
  }
  return str;
}

// loads userVar into and object
// path: path to be loaded into an object
// returns and object
function loadUserVar(path){
  var uv = FARR.getStrValue("uservarlist");
  uv = uv.replace(/(^|\n).*?=\s*(\n|$)/g,"$1");
  var uvs = uv.split("\n");
  var str = "";
  for(var i in uvs){
    if(uvs[i].trim() != ""){
      if(path && typeof(path) === "string" && path != "") {
        var r = new RegExp("^"+path);
        if(uvs[i].search(r) != -1){
          str += uvs[i].replace(r,"").replace(/^\./,"")+"\n";
        }
      }
    }
  }
  return strToObj(str);
}

// Copies unicode text into clipboard
function copyUnicodeClip(txt){
  var obj = new ActiveXObject("htmlfile");
  return obj.parentWindow.clipboardData.setData("text", txt);
}

// Sound object which enables you to:
// speak a text by speak function
// list voices by listVoices
// play a wav file by play function
// do it all asynchronously by async = true;
function Sound(){
  this.async = false;
  this.voice = false;

  this.listVoices = function(){
    try{
      var voiceObj = new ActiveXObject("Sapi.SpVoice");
      var array = [];
      for(var en = new Enumerator(voiceObj.GetVoices()); !en.atEnd(); en.moveNext()){
        array.push(en.item().GetDescription());
      }
    }catch(e){
      error("Sound object has failed on listVoices: " +
            "message: " + e.message + " " + "name: " + e.name);
    }
    return array;
  }

  this.speak = function(text){
    try{
      var voiceObj = new ActiveXObject("Sapi.SpVoice");
      if(typeof(this.voice) === "string") {
        voiceObj.Voice = voiceObj.GetVoices("Name="+this.voice).Item(0);
      }
      voiceObj.Speak(text, this.async == true ? 1 : 0 );
    }catch(e){
      error("Sound object has failed on speak: " +
            "message: " + e.message + " " + "name: " + e.name);
    }
  }

  this.play = function(path){
    try{
      var voiceObj = new ActiveXObject("Sapi.SpVoice");
      var voiceFile = new ActiveXObject("SAPI.SpFileStream.1");
      voiceFile.Open(path);
      voiceObj.Speakstream(voiceFile,  this.async == true ? 1 : 0 );
      voiceFile.Close();
    }catch(e){
      error("Sound object has failed on play: " +
            "message: " + e.message + " " + "name: " + e.name);
    }
  }

  this.record = function(text, path){
    try{
      var voiceObj = new ActiveXObject("Sapi.SpVoice");
      var voiceFile = new ActiveXObject("SAPI.SpFileStream.1");

      if(typeof(this.voice) === "string") {
        voiceObj.Voice = voiceObj.GetVoices("Name="+this.voice).Item(0);
      }

      voiceFile.Open(path, 3);
      voiceObj.AudioOutputStream = voiceFile;
      voiceObj.Speak(text, this.async == true ? 1 : 0 );
      voiceFile.Close();
    }catch(e){
      error("Sound object has failed on record: " +
            "message: " + e.message + " " + "name: " + e.name);
    }
  }
}
// Do not implement => used to change FARR values of the plugin (like aliasstr)
//function onGetStrValue(name) {
//}

// Local Variables:
// c-basic-offset: 2
// End:
